Index: code/branches/orxonox_tutorial/src/orxonox/objects/SpaceShip.cc
===================================================================
--- code/branches/orxonox_tutorial/src/orxonox/objects/SpaceShip.cc	(revision 1857)
+++ code/branches/orxonox_tutorial/src/orxonox/objects/SpaceShip.cc	(revision 1859)
@@ -205,5 +205,5 @@
     void SpaceShip::init()
     {
-        if (Settings::showsGraphics())
+        if (this->hasSpecialEffects())
         {
             // START CREATING THRUSTERS
@@ -258,41 +258,37 @@
 
             // START CREATING ADDITIONAL EFFECTS
-            if (this->hasSpecialEffects())
-            {
-                this->backlight_ = new Backlight(this->maxSpeed_, 0.8);
-                this->attachObject(this->backlight_);
-                this->backlight_->setPosition(-2.35, 0, 0.2);
-                this->backlight_->setColour(this->getProjectileColour());
-
-                this->smoke_ = new ParticleSpawner();
-                this->smoke_->setParticle("Orxonox/smoke5", LODParticle::normal, 0, 0, 3);
-                this->attachObject(this->smoke_);
-
-                this->fire_ = new ParticleSpawner();
-                this->fire_->setParticle("Orxonox/fire3", LODParticle::normal, 0, 0, 1);
-                this->attachObject(this->fire_);
-            }
+            this->backlight_ = new Backlight(this->maxSpeed_, 0.8);
+            this->attachObject(this->backlight_);
+            this->backlight_->setPosition(-2.35, 0, 0.2);
+            this->backlight_->setColour(this->getProjectileColour());
+
+            this->smoke_ = new ParticleSpawner();
+            this->smoke_->setParticle("Orxonox/smoke5", LODParticle::normal, 0, 0, 3);
+            this->attachObject(this->smoke_);
+
+            this->fire_ = new ParticleSpawner();
+            this->fire_->setParticle("Orxonox/fire3", LODParticle::normal, 0, 0, 1);
+            this->attachObject(this->fire_);
             // END CREATING ADDITIONAL EFFECTS
-
-            if (!this->isExactlyA(Class(SpaceShipAI)))
-            {
-                // START of testing crosshair
-                this->crosshairNear_.setBillboardSet("Orxonox/Crosshair", ColourValue(1.0, 1.0, 0.0), 1);
-                this->crosshairFar_.setBillboardSet("Orxonox/Crosshair", ColourValue(1.0, 1.0, 0.0), 1);
-
-                this->chNearNode_ = this->getNode()->createChildSceneNode(this->getName() + "near", Vector3(50.0, 0.0, 0.0));
-                this->chNearNode_->setInheritScale(false);
-                this->chFarNode_ = this->getNode()->createChildSceneNode(this->getName() + "far", Vector3(200.0, 0.0, 0.0));
-                this->chFarNode_->setInheritScale(false);
-
-                this->chNearNode_->attachObject(this->crosshairNear_.getBillboardSet());
-                this->chNearNode_->setScale(0.2, 0.2, 0.2);
-
-                this->chFarNode_->attachObject(this->crosshairFar_.getBillboardSet());
-                this->chFarNode_->setScale(0.4, 0.4, 0.4);
-                // END of testing crosshair
-            }
-        }
-        // END of testing crosshair
+        }
+
+        if (!this->isExactlyA(Class(SpaceShipAI)))
+        {
+            // START of testing crosshair
+            this->crosshairNear_.setBillboardSet("Orxonox/Crosshair", ColourValue(1.0, 1.0, 0.0), 1);
+            this->crosshairFar_.setBillboardSet("Orxonox/Crosshair", ColourValue(1.0, 1.0, 0.0), 1);
+
+            this->chNearNode_ = this->getNode()->createChildSceneNode(this->getName() + "near", Vector3(50.0, 0.0, 0.0));
+            this->chNearNode_->setInheritScale(false);
+            this->chFarNode_ = this->getNode()->createChildSceneNode(this->getName() + "far", Vector3(200.0, 0.0, 0.0));
+            this->chFarNode_->setInheritScale(false);
+
+            this->chNearNode_->attachObject(this->crosshairNear_.getBillboardSet());
+            this->chNearNode_->setScale(0.2, 0.2, 0.2);
+
+            this->chFarNode_->attachObject(this->crosshairFar_.getBillboardSet());
+            this->chFarNode_->setScale(0.4, 0.4, 0.4);
+            // END of testing crosshair
+        }
 
         createCamera();
@@ -311,15 +307,18 @@
         SUPER(SpaceShip, changedVisibility);
 
-        this->tt1_->setEnabled(this->isVisible());
-        this->tt2_->setEnabled(this->isVisible());
-        this->redBillboard_.setVisible(this->isVisible());
-        this->greenBillboard_.setVisible(this->isVisible());
+        if (this->hasSpecialEffects())
+        {
+            this->tt1_->setEnabled(this->isVisible());
+            this->tt2_->setEnabled(this->isVisible());
+            this->redBillboard_.setVisible(this->isVisible());
+            this->greenBillboard_.setVisible(this->isVisible());
+            this->rightThrusterFlare_.setVisible(this->isVisible());
+            this->leftThrusterFlare_.setVisible(this->isVisible());
+            this->smoke_->setVisible(this->isVisible());
+            this->fire_->setVisible(this->isVisible());
+            this->backlight_->setVisible(this->isVisible());
+        }
         this->crosshairNear_.setVisible(this->isVisible());
         this->crosshairFar_.setVisible(this->isVisible());
-        this->rightThrusterFlare_.setVisible(this->isVisible());
-        this->leftThrusterFlare_.setVisible(this->isVisible());
-        this->smoke_->setVisible(this->isVisible());
-        this->fire_->setVisible(this->isVisible());
-        this->backlight_->setVisible(this->isVisible());
     }
 
@@ -328,12 +327,15 @@
         SUPER(SpaceShip, changedActivity);
 
-        this->tt1_->setEnabled(this->isVisible());
-        this->tt2_->setEnabled(this->isVisible());
-        this->redBillboard_.setVisible(this->isVisible());
-        this->greenBillboard_.setVisible(this->isVisible());
+        if (this->hasSpecialEffects())
+        {
+            this->tt1_->setEnabled(this->isVisible());
+            this->tt2_->setEnabled(this->isVisible());
+            this->redBillboard_.setVisible(this->isVisible());
+            this->greenBillboard_.setVisible(this->isVisible());
+            this->rightThrusterFlare_.setVisible(this->isVisible());
+            this->leftThrusterFlare_.setVisible(this->isVisible());
+        }
         this->crosshairNear_.setVisible(this->isVisible());
         this->crosshairFar_.setVisible(this->isVisible());
-        this->rightThrusterFlare_.setVisible(this->isVisible());
-        this->leftThrusterFlare_.setVisible(this->isVisible());
     }
 
@@ -445,5 +447,5 @@
             this->cam_->tick(dt);
 
-        if (Settings::showsGraphics())
+        if (this->hasSpecialEffects())
         {
             if (this->smoke_)
@@ -565,13 +567,16 @@
             this->yaw(Radian(this->mouseYRotation_ * dt));
 
-        if (this->acceleration_.x > 0)
-        {
-            this->tt1_->setEnabled(true);
-            this->tt2_->setEnabled(true);
-        }
-        else
-        {
-            this->tt1_->setEnabled(false);
-            this->tt2_->setEnabled(false);
+        if (this->hasSpecialEffects())
+        {
+            if (this->acceleration_.x > 0)
+            {
+                this->tt1_->setEnabled(true);
+                this->tt2_->setEnabled(true);
+            }
+            else
+            {
+                this->tt1_->setEnabled(false);
+                this->tt2_->setEnabled(false);
+            }
         }
 
Index: code/branches/orxonox_tutorial/src/orxonox/objects/SpaceShip.h
===================================================================
--- code/branches/orxonox_tutorial/src/orxonox/objects/SpaceShip.h	(revision 1857)
+++ code/branches/orxonox_tutorial/src/orxonox/objects/SpaceShip.h	(revision 1859)
@@ -100,5 +100,5 @@
             
             virtual float getReloadTime() { return this->reloadTime_; }
-            virtual bool hasSpecialEffects() { return false; }
+            virtual bool hasSpecialEffects() { return true; }
 
             inline const Vector3& getDir() const
Index: code/branches/orxonox_tutorial/src/orxonox/objects/TutorialShip.cc
===================================================================
--- code/branches/orxonox_tutorial/src/orxonox/objects/TutorialShip.cc	(revision 1857)
+++ code/branches/orxonox_tutorial/src/orxonox/objects/TutorialShip.cc	(revision 1859)
@@ -3,26 +3,5 @@
  *                    > www.orxonox.net <
  *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Oliver 'greenman' Scheuss, Reto '1337' Grieder
- *   Co-authors:
- *      ...
- *
+ *                         TUTORIAL
  */
 
@@ -36,5 +15,4 @@
 #include "util/Convert.h"
 #include "util/Debug.h"
-#include "util/Math.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/ConsoleCommand.h"
@@ -90,4 +68,7 @@
         // are loaded too.
         SUPER(TutorialShip, XMLPort, xmlelement, mode);
+
+        // Display a message in shell/logfile/console
+        COUT(3) << "TutorialShip was loaded." << std::endl;
     }
 
@@ -105,9 +86,5 @@
     }
 
-    // virtual function used by back end class SpaceShip.
-    float TutorialShip::getReloadTime()
-    {
-        return this->reloadTime_;
-    }
+    /*** NOT SO IMPORTATANT... ***/
 
     // run time update method. Gets called every frame with the delta time that
@@ -119,4 +96,10 @@
     }
 
+    // virtual function used by back end class SpaceShip.
+    float TutorialShip::getReloadTime()
+    {
+        return this->reloadTime_;
+    }
+
     // Fire a projectile. Delegated to the back end class SpaceShip.
     // Function content is insignificant for the tutorial.