Index: /orxonox/branches/gui/gui/orxonox_gui.c
===================================================================
--- /orxonox/branches/gui/gui/orxonox_gui.c	(revision 1866)
+++ /orxonox/branches/gui/gui/orxonox_gui.c	(revision 1867)
@@ -1,2 +1,28 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer:
+*/
+
+
 #include "orxonox_gui.h"
 #include "orxonox_gui_video.h"
Index: /orxonox/branches/gui/gui/orxonox_gui_audio.c
===================================================================
--- /orxonox/branches/gui/gui/orxonox_gui_audio.c	(revision 1866)
+++ /orxonox/branches/gui/gui/orxonox_gui_audio.c	(revision 1867)
@@ -1,2 +1,27 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer:
+*/
+
 #include "orxonox_gui.h"
 
Index: /orxonox/branches/gui/gui/orxonox_gui_exec.c
===================================================================
--- /orxonox/branches/gui/gui/orxonox_gui_exec.c	(revision 1866)
+++ /orxonox/branches/gui/gui/orxonox_gui_exec.c	(revision 1867)
@@ -1,2 +1,28 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer:
+*/
+
+
 #include "orxonox_gui_exec.h"
 GtkWidget *exec_flags_label;
Index: /orxonox/branches/gui/gui/orxonox_gui_file.c
===================================================================
--- /orxonox/branches/gui/gui/orxonox_gui_file.c	(revision 1866)
+++ /orxonox/branches/gui/gui/orxonox_gui_file.c	(revision 1867)
@@ -1,2 +1,28 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer:
+*/
+
+
 #include <sys/stat.h>
 #include "orxonox_gui_file.h"
Index: /orxonox/branches/gui/gui/orxonox_gui_video.c
===================================================================
--- /orxonox/branches/gui/gui/orxonox_gui_video.c	(revision 1866)
+++ /orxonox/branches/gui/gui/orxonox_gui_video.c	(revision 1867)
@@ -1,2 +1,28 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer:
+*/
+
+
 #include "orxonox_gui_video.h"
 