Index: /orxonox/branches/gui/console/Makefile
===================================================================
--- /orxonox/branches/gui/console/Makefile	(revision 1879)
+++ /orxonox/branches/gui/console/Makefile	(revision 1880)
@@ -51,5 +51,5 @@
 
 .cc.o:
-	@ echo "$@ is being comiled..."
+	@ echo "$@ is being compiled..."
 	@ $(CXX) -c $(CFLAGS) -I$(INCDIR) -o $@ $<
 
Index: /orxonox/branches/gui/console/orxonox_console.cc
===================================================================
--- /orxonox/branches/gui/console/orxonox_console.cc	(revision 1879)
+++ /orxonox/branches/gui/console/orxonox_console.cc	(revision 1880)
@@ -26,11 +26,9 @@
 
 #include "orxonox_console.h"
+
 using namespace std;
 
 void OrxonoxConsole::createWindow ()
 {
-  OrxonoxConsoleEntry entry;
-  OrxonoxConsoleLog log;
-  
   
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
Index: /orxonox/branches/gui/console/orxonox_console.h
===================================================================
--- /orxonox/branches/gui/console/orxonox_console.h	(revision 1879)
+++ /orxonox/branches/gui/console/orxonox_console.h	(revision 1880)
@@ -12,4 +12,7 @@
 #include "orxonox_console_log.h"
 
+OrxonoxConsoleLog log;
+OrxonoxConsoleEntry entry;
+  
 class OrxonoxConsole {
   
Index: /orxonox/branches/gui/console/orxonox_console_entry.cc
===================================================================
--- /orxonox/branches/gui/console/orxonox_console_entry.cc	(revision 1879)
+++ /orxonox/branches/gui/console/orxonox_console_entry.cc	(revision 1880)
@@ -27,4 +27,8 @@
 #include "orxonox_console_entry.h"
 
+OrxonoxConsoleEntry::OrxonoxConsoleEntry(OrxonoxConsoleLog* log)
+{
+  consoleLog = log;
+}
 
 GtkWidget* OrxonoxConsoleEntry::createEntry()
@@ -38,10 +42,12 @@
     {
       entry = gtk_entry_new();
+      g_signal_connect(GTK_ENTRY(entry), "activate", G_CALLBACK(submit), entry);
       gtk_box_pack_start(GTK_BOX(entrybox), entry, TRUE, TRUE, 5);
       
       
       button = gtk_button_new_with_label("Submit");
+      g_signal_connect(GTK_BUTTON(button), "clicked", G_CALLBACK(submit), entry);
       gtk_box_pack_start(GTK_BOX(entrybox), button, FALSE, FALSE, 5);
-      
+
     }
     gtk_container_add(GTK_CONTAINER(frame), entrybox);
@@ -50,2 +56,19 @@
 }
 
+void OrxonoxConsoleEntry::submit(GtkWidget *widget, GtkWidget* data)
+{
+  char* entryText = (char*)gtk_entry_get_text(GTK_ENTRY(data));
+  printf("%s\n", entryText);
+
+  gtk_entry_set_text(GTK_ENTRY(data),"");
+  free (entryText);
+  return;
+}
+
+
+void OrxonoxConsoleEntry::sendtoLog(char* submitText)
+{
+  printf("submitting %s\n", submitText);
+
+  return;
+}
Index: /orxonox/branches/gui/console/orxonox_console_entry.h
===================================================================
--- /orxonox/branches/gui/console/orxonox_console_entry.h	(revision 1879)
+++ /orxonox/branches/gui/console/orxonox_console_entry.h	(revision 1880)
@@ -8,4 +8,6 @@
 #include <gtk/gtk.h> 
 
+#include "orxonox_console_log.h"
+
 class OrxonoxConsoleEntry {
   
@@ -16,13 +18,17 @@
   GtkWidget *button;
   GtkWidget *entry;
+  OrxonoxConsoleLog* consoleLog;
   
 
 
  public:
+  OrxonoxConsoleEntry(OrxonoxConsoleLog* log);
+  
   GtkWidget* createEntry(void);
-
-    
+  static void submit(GtkWidget *widget, GtkWidget* data);
+  void sendtoLog(char* submitText);
 
 };
+  
 
 #endif
Index: /orxonox/branches/gui/console/orxonox_console_log.cc
===================================================================
--- /orxonox/branches/gui/console/orxonox_console_log.cc	(revision 1879)
+++ /orxonox/branches/gui/console/orxonox_console_log.cc	(revision 1880)
@@ -29,20 +29,36 @@
 GtkWidget* OrxonoxConsoleLog::createLog()
 {
-  //frame = gtk_frame_new ("Console Log:");
-  frame = gtk_scrolled_window_new (NULL, NULL);
-
-  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (frame),
-				  GTK_POLICY_AUTOMATIC,
-				  GTK_POLICY_AUTOMATIC);
-
-  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (frame),
-				       GTK_SHADOW_IN);
-  gtk_container_set_border_width (GTK_CONTAINER(frame), 5);
-  
-  log = gtk_text_view_new();
-  gtk_text_view_set_editable(GTK_TEXT_VIEW(log), FALSE);
-  gtk_container_add(GTK_CONTAINER(frame), log);
-  
+  frame = gtk_frame_new ("Console Log:");
+  {
+    scrollframe = gtk_scrolled_window_new (NULL, NULL);
+    logtext = new char;
+    
+    gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrollframe),
+				    GTK_POLICY_AUTOMATIC,
+				    GTK_POLICY_AUTOMATIC);
+    
+    gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrollframe),
+					 GTK_SHADOW_IN);
+    gtk_container_set_border_width (GTK_CONTAINER(scrollframe), 5);
+    
+    log = gtk_text_view_new();
+    gtk_text_view_set_editable(GTK_TEXT_VIEW(log), FALSE);
+    gtk_container_add(GTK_CONTAINER(scrollframe), log);
+    gtk_container_add(GTK_CONTAINER(frame),scrollframe);
+  }
   return (frame);
 }
 
+void OrxonoxConsoleLog::appendText(char* append)
+{
+  printf ("appending %s\n", append);
+  /*  strcat(logtext, append);
+  printf(logtext);
+  return;*/
+}
+
+void OrxonoxConsoleLog::clear()
+{
+  sprintf(logtext, "");
+  return;
+}
Index: /orxonox/branches/gui/console/orxonox_console_log.h
===================================================================
--- /orxonox/branches/gui/console/orxonox_console_log.h	(revision 1879)
+++ /orxonox/branches/gui/console/orxonox_console_log.h	(revision 1880)
@@ -5,7 +5,8 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <string.h>
 
 /* GTK headers */
-#include <gtk/gtk.h> 
+#include <gtk/gtk.h>
 
 class OrxonoxConsoleLog {
@@ -13,7 +14,10 @@
  private:
   GtkWidget *frame;
+  GtkWidget *scrollframe;
   GtkWidget *logbox;
   GtkWidget *log;
   GtkWidget *label;
+
+  char *logtext;
   
   
@@ -21,8 +25,9 @@
 
  public:
+  
   GtkWidget* createLog(void);
 
-    
-
+  void OrxonoxConsoleLog::appendText(char* append);  
+  void OrxonoxConsoleLog::clear();
 };
 